%  clc, clear, close all
%  
%  %% compile
%  % mex kdtree_build.cpp
%  % mex kdtree_k_nearest_neighbors.cpp
%  % disp('necessary files compiled.');
%  
%  %% test1: small test for evaluation and visualizatoin
%  rand('seed',1);
%  p = rand( 30,  2 ); % input data
%  q = [ .5, .5 ]'; k = 5; % query data (buggy)
%  
%  % execute query by kd-tree and by linear scan
%  tree = kdtree_build( p );
%  idxs1 = kdtree_k_nearest_neighbors( tree,q,k );
%  dist = zeros( size(p,1), 1 );
%  for i=1:size(p,1)
%      dist( i ) = sqrt( sum( ( p(i,:)-q' ).^2 ) );
%  end
%  [IGNORE, idxs2] = sort( dist,'ascend' );
%  idxs2 = idxs2(1:k); % keep only first k entries
%  
%  %%% visualize indexes returned by query
%  disp( ['(fullsearch)   kNN indexes: ', sprintf('%d ', idxs2 ) ] );
%  disp( ['(kdtreesearch) kNN indexes: ', sprintf('%d ', idxs1 ) ] );
%  
%  %%% visualize
%  xlim( [0 1] );
%  ylim( [0 1] );
%  hold on; axis equal; axis off;
%  plot( p(:,1), p(:,2), '.b');
%  plot(q(1), q(2),'.r');
%  plot(p(idxs2,1), p(idxs2,2),'or');
%  plot(p(idxs1,1), p(idxs1,2),'+y');
%  legend('database', 'query', '(matlab) result', '(kdtree) result');
%  
%  %%% convert input data to C++ format (for testing)
%  % for i=1:size(p,1)
%  %    disp(sprintf('A[%d][0] = %.2f; A[%d][1] = %.2f;', i-1, p(i,1), i-1, p(i,2) )); 
%  % end
%  
%  return
%
