% SURF2STL   Write STL file from surface data.
%    SURF2STL('filename',X,Y,Z) writes a stereolithography (STL) file
%    for a surface with geometry defined by three matrix arguments, X, Y
%    and Z.  X, Y and Z must be two-dimensional arrays with the same size.
% 
%    SURF2STL('filename',x,y,Z), uses two vector arguments replacing
%    the first two matrix arguments, which must have length(x) = n and
%    length(y) = m where [m,n] = size(Z).  Note that x corresponds to
%    the columns of Z and y corresponds to the rows.
% 
%    SURF2STL('filename',dx,dy,Z) uses scalar values of dx and dy to
%    specify the x and y spacing between grid points.
% 
%    SURF2STL(...,'mode') may be used to specify the output format.
% 
%      'binary' - writes in STL binary format (default)
%      'ascii'  - writes in STL ASCII format
% 
%    Example:
% 
%      surf2stl('test.stl',1,1,peaks);
% 
%    See also SURF.
% 
%    Author: Bill McDonald, 02-20-04
%
